<%@page import="eu.europa.ec.re3gistry.model.Languagecode"%>
<%@page import="eu.europa.ec.re3gistry.re3gistryimport.constants.Constants"%>
<%@page import="eu.europa.ec.re3gistry.model.Localization"%>
<%@page import="eu.europa.ec.re3gistry.model.Itemclass"%>
<%@page import="eu.europa.ec.re3gistry.model.Item"%>
<%@page import="eu.europa.ec.re3gistry.model.Register"%>
<%@page import="javax.persistence.Query"%>
<%@page import="java.util.List"%>
<%@page import="javax.persistence.EntityManager"%>
<%@page import="javax.persistence.Persistence"%>
<%@page import="eu.europa.ec.re3gistry.re3gistryimport.manager.Configuration"%>
<%@page import="javax.persistence.EntityManagerFactory"%>
<%
    //Getting required parameter
    String regUUID = request.getParameter("reg");
    String itemClassUUID = request.getParameter("itc");

    //Loading required properties
    String KEY_PERSISTENCE_UNIT_NAME = "persistence.unit.name";
    EntityManagerFactory factory;
    String persistenceUnitName = Configuration.getInstance().getProperty(KEY_PERSISTENCE_UNIT_NAME, "Re3gistry");
    //Istantiating persistence manager
    factory = Persistence.createEntityManagerFactory(persistenceUnitName);
    EntityManager em = factory.createEntityManager();
    
    Query q = em.createNamedQuery("Register.findByUuid");
    q.setParameter("uuid", regUUID);
    Register reg = (Register)q.getSingleResult();

    q = em.createNamedQuery("Itemclass.findByUuid");
    q.setParameter("uuid", itemClassUUID);
    Itemclass ic = (Itemclass) q.getSingleResult();

    q = em.createNamedQuery("Item.findByRegisterItemclass");
    q.setParameter("register", reg);
    q.setParameter("itemclass", ic);
    List<Item> itlist = (List<Item>) q.getResultList();
    
    //Getting the current language
    //@TODO: set it dynamic
    q = em.createNamedQuery("Languagecode.findByUuid");
    q.setParameter("uuid", "1");
    Languagecode lc = (Languagecode)q.getSingleResult();

    if(ic.getOrdernumber()>0){
    %>
    <label for="itemclass-p">Choose the collection's father for the selected itemclass</label>
    <ul>
    <%
    q = em.createNamedQuery("Itemclass.findByRegister");
    q.setParameter("register", reg);
    List<Itemclass> itcl = (List<Itemclass>) q.getResultList();
    for(int i = 0; i < itcl.size(); i++){
        Itemclass tmp = itcl.get(i);
        if(tmp.getUuid() != ic.getUuid()){
        q = em.createNamedQuery("Localization.findByItemclassLanguagecode");
        q.setParameter("itemclass", tmp);
        q.setParameter("language", lc);
        Localization l = (Localization)q.getSingleResult();
    %>
    <li><input type="radio" name="itemclass-collection" value="<%=tmp.getUuid()%>"/>&nbsp;&nbsp;<%= l.getLabel() %></li>
    <%
       }
       }
    %>
    </ul>
    <%
    }
%>
<label for="csv">Select the import file</label>
<%
if(itlist.size() > 0){
%>
<p>Warning: the first import for this item class has already been done. You can 
only load another language for the current data.</p>
<input type="hidden" name="action" value="<%=Constants.ACTION_TYPE_LANGUAGEIMPORT%>"/>
<%
}else{
%>
<input type="hidden" name="action" value="<%=Constants.ACTION_TYPE_ITEMIMPORT%>"/>
<%
}
%>
<p>Select the file: <input type="file" name="csv" /></p>

<label for="languagecode">Select the import language</label>
<select name="languagecode">
<%
q = em.createNamedQuery("Languagecode.findAll");
List <Languagecode> lcs = (List<Languagecode>)q.getResultList();
for(Languagecode l : lcs){
%>
<option value="<%= l.getUuid() %>"><%= l.getLabel() %></option>
<%
}
%>
</select>

<br/><br/><input type="submit" value="Start import" />