/*
* Copyright 2010,2013 EUROPEAN UNION
* Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
* the European Commission - subsequent versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* http://ec.europa.eu/idabc/eupl
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the Licence is distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the Licence for the specific language governing permissions and
* limitations under the Licence.
*
* Date: 14/06/2013
* Authors: European Commission, Joint Research Centre
* Daniele Francioli, Emanuela Epure
* inspire-registry-info@jrc.ec.europa.eu
*
* This work was supported by the EU  Interoperability Solutions for
* European Public Administrations Programme (http://ec.europa.eu/isa)
* through Action 1.17: Re-usable INSPIRE Reference Platform 
* (http://ec.europa.eu/isa/actions/01-trusted-information-exchange/1-17action_en.htm).
*/

package eu.europa.ec.re3gistry.re3gistryexport.constants;

public class Constants {

    public static String EXPORT_DATABASE_LABEL = "Export";
    public static String EXPORT_XML_LABEL = "Export XML";
    public static String EXPORT_JSON_LABEL = "Export JSON";
    public static String THEME_LABEL = "Theme";
    public static String APPLICATION_SCHEMA_LABEL = "Application Schema";
    public static String ITEM_CLASS_LABEL = "Item Class";
    public static int EXPORT_XML = 1;
    public static int EXPORT_JSON = 2;
    public static String EXPORT_FORM_ITEM_NAME_JSON = "typeJson";
    public static String EXPORT_FORM_ITEM_NAME_ATOM = "typeAtom";
    public static String EXPORT_FORM_ITEM_NAME_RDF = "typeRdf";
    public static String EXPORT_ITEM_NAME_JSON = "json";
    public static String EXPORT_ITEM_NAME_ATOM = "atom";
    public static String EXPORT_ITEM_NAME_RDF = "rdf";
}